/////////////////////////////////////////////////////////////////////////////
//  Projekt: STest - testovn slovek a tvorba test                     //
//  Verze: 2                                                               //
//  Autor: David Martinek                                                  //
//  Adresa: Majakovskho 2148/60, Karvin 7, 734 01                        //
//                                                                         //
//  Funkce modulu: Formul pro editaci test                              //
//  Datum: 19.10.1999                                                      //
/////////////////////////////////////////////////////////////////////////////
unit EditFrm;

interface

uses
  Windows, Messages, SysUtils, Forms, Dialogs, StdCtrls, Menus, ComCtrls,
  Controls, Buttons, Classes,
  WordList;

const
  KeyEnter = #13;                   // kd klvesy Enter
  NoName = 'Bez nzvu';
  AppName = 'STest';
type
  // formul
  TEditForm = class(TForm)
    OriginListBox: TListBox;
    TransListBox: TListBox;
    OriginEdit: TEdit;
    TransEdit: TEdit;
    Menu: TMainMenu;
    SbrM: TMenuItem;
    EndM: TMenuItem;
    OrL: TLabel;
    TrL: TLabel;
    NextButton: TButton;
    PrevButton: TButton;
    N1: TMenuItem;
    SavAsM: TMenuItem;
    SaveDialog: TSaveDialog;
    ResetButton: TButton;
    OriginSpeedButton: TSpeedButton;
    TransSpeedButton: TSpeedButton;
    StatusBar1: TStatusBar;
    DelOriginSpeedButton: TSpeedButton;
    EditOriginSpeedButton: TSpeedButton;
    DelTransSpeedButton: TSpeedButton;
    EditTransSpeedButton: TSpeedButton;
    OpenM: TMenuItem;
    OpenDialog: TOpenDialog;
    FirstButton: TSpeedButton;
    LastButton: TSpeedButton;
    SaveM: TMenuItem;
    NewM: TMenuItem;
    OriginCommentEdit: TEdit;
    TransCommentEdit: TEdit;
    HlpM: TMenuItem;
    ObsM: TMenuItem;
    N2: TMenuItem;
    OpM: TMenuItem;
    ListBox: TListBox;
    procedure OriginEditChange(Sender: TObject);
    procedure TransEditChange(Sender: TObject);
    procedure OriginSpeedButtonClick(Sender: TObject);
    procedure TransSpeedButtonClick(Sender: TObject);
    procedure OriginEditKeyPress(Sender: TObject; var Key: Char);
    procedure TransEditKeyPress(Sender: TObject; var Key: Char);
    procedure ResetButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure EndMClick(Sender: TObject);
    procedure DelOriginSpeedButtonClick(Sender: TObject);
    procedure DelTransSpeedButtonClick(Sender: TObject);
    procedure OriginListBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TransListBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TransListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OriginListBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EditOriginSpeedButtonClick(Sender: TObject);
    procedure EditTransSpeedButtonClick(Sender: TObject);
    procedure SavAsMClick(Sender: TObject);
    procedure PrevButtonClick(Sender: TObject);
    procedure OpenMClick(Sender: TObject);
    procedure FirstButtonClick(Sender: TObject);
    procedure LastButtonClick(Sender: TObject);
    procedure NewMClick(Sender: TObject);
    procedure SaveMClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpMClick(Sender: TObject);
    procedure ObsMClick(Sender: TObject);
    procedure TransCommentEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OriginCommentEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBoxClick(Sender: TObject);
  private
    { Private declarations }
    List : TWordList;         // seznam pr

    Modified : boolean;   // indiktor zmny
    FormModified : boolean; // indiktor zmny na formuli
    FFileName : String;   // jmno aktulnho souboru

    FActualIndex,          // index aktulnho pru
    FMaxIndex : integer;   // index poslednho pru
    ActualPair : TPair;
    // podchyt udlost pro minimalizaci okna
    procedure MinMsg(var Msg : TWMSysCommand); message WM_SYSCOMMAND;
    // pid text z Editu do ListBoxu
    procedure EditToListBox(Edit : TEdit; ListBox : TListBox);
    // vrt pr zskan z ListBox
    function GetPair(var Pair : TPair) : boolean;
    // zjist, jestli je z ListBox mono poskldat zznam
    function GetPairOk : boolean;
    // zajist povolen a zakzn tlatek pro editaci Listbox
    procedure OriginSpeedButtons;
    procedure TransSpeedButtons;
    // zajist povolen a zakzn tlatek Dal a Minul
    procedure PrevNextButtons;
    // nate data ze souboru
    procedure OpenFile;
    procedure LoadListBox;
    function GetItemString(Item : TPair; I : integer) : string;

    // oet situaci, kdy se posouv na njakou pedchoz poloku
    procedure PrevMove(Index : integer);
    // ----- || ----- nsledujc poloku
    procedure NextMove(Index : integer);
    function AttendMove : boolean;

    procedure ResetForm;
    procedure FillActualForm;

(*    procedure IncIndexs;
    procedure DecIndexs;
*)
    // nastav hodnoty vlastnost
    procedure SetActualIndex(Value : integer);
    procedure SetMaxIndex(Value : integer);
    procedure SetFileName(Value : String);
  published
    property ActualIndex : integer read FActualIndex write SetActualIndex;
    property MaxIndex : integer read FMaxIndex write SetMaxIndex;
    property FileName : string read FFileName write SetFileName;
  public
    { Public declarations }
  end; // TEditForm

// zobraz formul pro editaci
procedure ShowEditForm(Fname : String; I : Integer);
// rozkouskuje string na slova a napln jimi ListBox
procedure StringToListBox(S : String; ListBox : TListBox);

var
  EditForm: TEditForm;

implementation
uses AboutFrm;
{$R *.DFM}

//////////////////////////////////////////////////////////////////////////////
// zobraz formul pro editaci
procedure ShowEditForm(Fname : String; I : Integer);
begin
  EditForm := TEditForm.Create(Application);
  try
    EditForm.FileName := Fname;
    EditForm.ActualIndex := I;
    if Fname <> NoName then EditForm.OpenFile;
    EditForm.ShowModal;
  finally
    EditForm.Release;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
// napln poloky formule aktulnmi hodnotami podle ActualIndexu
procedure TEditForm.FillActualForm;
begin
  ActualPair := List.Items[ActualIndex];
  StringToListBox(ActualPair.Origin, OriginListBox);
  StringToListBox(ActualPair.Trans, TransListBox);
  OriginCommentEdit.Text := ActualPair.OriginComment;
  TransCommentEdit.Text := ActualPair.TransComment;
end;

//////////////////////////////////////////////////////////////////////////////
function TEditForm.GetItemString(Item : TPair; I : integer) : string;
var
  S : string;
begin
  S := Item.GetWord(amOrigin,0);
{  if length(S) > 10 then
    Delete(S, 10, length(S));
}
  Result := IntToStr(I)+'. ' + S + ' <--> ';
  S := Item.GetWord(amTrans, 0);
{ if length(S) > 10 then
    Delete(S, 10, length(S));
}
  Result := Result + S;
end;

//////////////////////////////////////////////////////////////////////////////
// nate data z Listu do ListBoxu
procedure TEditForm.LoadListBox;
var
  I : integer;
begin
  if FormModified then
  begin
    ListBox.Clear;
    for I := 0 to List.Count - 1 do
    begin
      ListBox.Items.Add(GetItemString(List.Items[I], I));
    end;
    ListBox.Items.Add(' ');
    ListBox.ItemIndex := ActualIndex;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
// nate data ze souboru
procedure TEditForm.OpenFile;
begin
  List.Free;
  List := TWordList.Create;
  ResetButtonClick(EditForm);
  List.LoadFromFile(FileName);
  LoadListBox;
  if List.GetError > 0 then
  begin
    Application.MessageBox(PChar('Chyba pi natn souboru.'+#13#10+
      List.GetErrorText(List.GetError)), 'Chyba', mb_OK + mb_iconerror);
    NewMClick(EditForm);
    Exit;
  end;
  // ActualIndex := ActualIndex;

  Modified := false;
  FormModified := false;

  MaxIndex := List.Count - 1;
  if List.Count > 0 then
  begin
    FillActualForm;
{    ActualPair := List.Items[ActualIndex];
    StringToListBox(ActualPair.Origin, OriginListBox);
    StringToListBox(ActualPair.Trans, TransListBox);
    OriginCommentEdit.Text := ActualPair.OriginComment;
    TransCommentEdit.Text := ActualPair.TransComment;
}
  end;
end;

//////////////////////////////////////////////////////////////////////////////
// pid text z Editu do ListBoxu
procedure TEditForm.EditToListBox(Edit : TEdit; ListBox : TListBox);
begin
  if (ListBox.Items.IndexOf(Edit.Text) = -1) and
     (Edit.Text <> '') then
  begin
    ListBox.Items.Add(Edit.Text);
    Modified := true;
    FormModified := true;
  end;
  NextButton.Enabled := (OriginListBox.Items.Count > 0) and
    (TransListBox.Items.Count > 0);
  LastButton.Enabled := NextButton.Enabled;
  Edit.SelectAll;
  Edit.SetFocus;
end; // EditToListBox

//////////////////////////////////////////////////////////////////////////////
// najde slovka v textu a ulo je do ListBoxu
procedure StringToListBox(S : String; ListBox : TListBox);

{######################################################}
// vrt slovo vypreparovan ze stringu
function GetWord(var odkud : integer) : string;
var
  I, zac : integer;
begin  // GetWord
  Result := '';
  zac := odkud;
  for I := zac to Length(S) do
  begin
    odkud := I;
    if S[I] = WordSeparator then Break;
    Result := Result + S[I];
  end;
end;  // GetWord

var
  I : integer;
  slovo : string;
begin  // StringToListBox
  I := 1;
  while (I <= Length(S)) do
  begin
    slovo := GetWord(I);
    ListBox.Items.Add(slovo);
    Inc(I);
  end;
end;  // StringToListBox

//////////////////////////////////////////////////////////////////////////////
// vrt pr zskan z ListBox
function TEditForm.GetPair(var Pair : TPair) : boolean;
var
  I : integer;
begin
  Result := true;
  if not GetPairOk then
  begin
    if Application.MessageBox('Aktuln zznam nen pln, chcete jej zruit?',
      AppName, MB_YESNO + MB_ICONQUESTION) = IDYES then
    begin
      List.Remove(Pair);
      Pair.Free;
      Pair := nil;
    end
    else
      Result := false;
  end
  else
    with Pair do
    begin
      Origin := '';
      Trans := '';
      for I := 0 to OriginListBox.Items.Count - 1 do
        if I = 0 then
          Origin := OriginListBox.Items[I]
        else
          Origin := Origin + WordSeparator + OriginListBox.Items[I];

      for I := 0 to TransListBox.Items.Count - 1 do
        if I = 0 then
          Trans := TransListBox.Items[I]
        else
          Trans := Trans + WordSeparator + TransListBox.Items[I];

      OriginComment := Trim(OriginCommentEdit.Text);
      TransComment := Trim(TransCommentEdit.Text);
      LoadListBox;
    end;
end; // GetPair

//////////////////////////////////////////////////////////////////////////////
// zjist, jestli je z ListBox mono poskldat zznam
function TEditForm.GetPairOk : boolean;
begin
  Result := (OriginListBox.Items.Count > 0) and (TransListBox.Items.Count > 0);
end; // GetPairOk

//////////////////////////////////////////////////////////////////////////////
// zajist sprvn povolen tlatek pro editaci OriginListBoxu
procedure TEditForm.OriginSpeedButtons;
begin
  with OriginListBox do
  begin
    DelOriginSpeedButton.Enabled := ItemIndex >= 0;
    EditOriginSpeedButton.Enabled := ItemIndex >= 0;
  end;
  PrevNextButtons;
end; // OriginSpeedButtons

//////////////////////////////////////////////////////////////////////////////
// zajist sprvn povolen tlatek pro editaci TransListBoxu
procedure TEditForm.TransSpeedButtons;
begin
  with TransListBox do
  begin
    DelTransSpeedButton.Enabled := ItemIndex >= 0;
    EditTransSpeedButton.Enabled := ItemIndex >= 0;
  end;
  PrevNextButtons;
end; // TransSpeedButtons

//////////////////////////////////////////////////////////////////////////////
// zajist povolen a zakzn tlatek Dal a Minul
procedure TEditForm.PrevNextButtons;
begin
  PrevButton.Enabled := ActualIndex > 0;
  FirstButton.Enabled := ActualIndex > 0;
  NextButton.Enabled := (MaxIndex <> ActualIndex) or
    (MaxIndex <> List.Count) or
    ((OriginListBox.Items.Count > 0) and (TransListBox.Items.Count > 0));
  LastButton.Enabled := NextButton.Enabled;
end; // PrevNextButtons

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.SetActualIndex(Value : integer);
begin
  if Value < 0 then Value := 0;
  if Value <> FActualIndex then
  begin
    FActualIndex := Value;
    StatusBar1.Panels.Items[0].Text := 'A: ' + IntToStr(Value);
//    if ListBox.Items.Count < (Value + 1) then
    ListBox.ItemIndex := Value;
  end;
  PrevNextButtons;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.SetMaxIndex(Value : integer);
begin
  if Value < 0 then Value := 0;
  if Value <> FMaxIndex then
  begin
    FMaxIndex := Value;
    StatusBar1.Panels.Items[1].Text := 'M: ' + IntToStr(Value);
    LoadListBox;
  end;
  PrevNextButtons;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.SetFileName(Value : String);
begin
  if Value <> FFileName then
  begin
    FFileName := Value;
    Caption := AppName + ' - ' + ExtractFileName(Value);
    Application.Title := Caption;
  end;
end;
(*
//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.IncIndexs;
begin
  if (MaxIndex = ActualIndex) then
    MaxIndex := MaxIndex + 1;
  ActualIndex := ActualIndex + 1;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.DecIndexs;
begin
  ActualIndex := ActualIndex - 1;
  MaxIndex := MaxIndex - 1;
end;
*)
//////////////////////////////////////////////////////////////////////////////
function TEditForm.AttendMove : boolean;
begin
  Result := true;

  // bude se vytvet nov zznam
  if (MaxIndex = ActualIndex)and(MaxIndex = List.Count) then
  begin
    ActualPair := TPair.Create;      // alokuje pam pro dal zznam
    if GetPair(ActualPair) then  // pevede daje z ListBox do zznamu
      begin
        if ActualPair <> nil then
        begin
          List.Add(ActualPair); // pid zznam do seznamu
          LoadListBox;
          Modified := true;
        end
        else
          MaxIndex := MaxIndex - 1;
      end
    else
      begin
        ActualPair.Free;
        ActualPair := nil;
        Exit;
      end;
  end
  else
  begin
    if GetPair(ActualPair) then
      begin
        if ActualPair = nil then
          MaxIndex := MaxIndex - 1;
      end
    else
      Exit;
  end;

  Result := false;
end;

//////////////////////////////////////////////////////////////////////////////
// oet situaci, kdy se posouv na njakou pedchoz poloku
procedure TEditForm.PrevMove(Index : integer);
begin
  try
    if AttendMove then Exit;
    ActualIndex := Index;
    ResetForm;   // vyist okno
    OriginEdit.SetFocus;  // nastav zamen na prvn editovac box
    FillActualForm;
    FormModified := false;
  finally
    PrevNextButtons;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
// ----- || ----- nsledujc poloku
procedure TEditForm.NextMove(Index : integer);
begin
  try
    if AttendMove then Exit;
    if Index > MaxIndex then
      begin
         ActualIndex := List.Count;
         MaxIndex := ActualIndex;
      end
    else
      ActualIndex := Index;
    ResetForm;   // vyist okno
    OriginEdit.SetFocus;  // nastav zamen na prvn editovac box
    if ActualIndex < List.Count then FillActualForm; // jsme uprosted seznamu
    FormModified := false;
  finally
    PrevNextButtons;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
//////// Obsluha udlost formule //////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.FormCreate(Sender: TObject);
begin
  List := TWordList.Create;  // vytvo seznam pro zznamy
  Modified := false;
  FormModified := false;
//  FActualIndex := 2;
//  FMaxIndex := 2;
//  ActualIndex := 0;
//  MaxIndex := 0;
end;

//////////////////////////////////////////////////////////////////////////////
// podchyt udlost pro minimalizaci okna
// protoe tohle nen hlavn okno aplikace, pi normln minimalizaci
// by se to nezmenilo do lity, ale do ikony na ploe
procedure TEditForm.MinMsg(var Msg : TWMSysCommand);
begin
  if Msg.CmdType = SC_MINIMIZE then
    Application.Minimize    // minimalizuje celou aplikaci
  else
    inherited;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.FormDestroy(Sender: TObject);
begin
//  if Modified then SaveToFile;
  List.Free;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.OriginEditChange(Sender: TObject);
begin
  OriginSpeedButton.Enabled := Length(OriginEdit.Text) <> 0;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.TransEditChange(Sender: TObject);
begin
   TransSpeedButton.Enabled := Length(TransEdit.Text) <> 0;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.OriginSpeedButtonClick(Sender: TObject);
begin
  EditToListBox(OriginEdit,OriginListBox);
  Modified := true;
  FormModified := true;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.TransSpeedButtonClick(Sender: TObject);
begin
  EditToListBox(TransEdit, TransListBox);
  Modified := true;
  FormModified := true;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.OriginEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = KeyEnter then
  begin
    EditToListBox(OriginEdit,OriginListBox);
    Key := #0;  // seere znak
  end;
end; // OriginEditKeyPress

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.TransEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = KeyEnter then
  begin
    EditToListBox(TransEdit,TransListBox);
    Key := #0;  // seere znak
  end;
end; // TransEditKeyPress

//////////////////////////////////////////////////////////////////////////////
// vyist formul
procedure TEditForm.ResetForm;
begin
  OriginEdit.Text := '';
  TransEdit.Text := '';
  OriginCommentEdit.Text := '';
  TransCommentEdit.Text := '';
  OriginListBox.Items.Clear;
  TransListBox.Items.Clear;
  DelOriginSpeedButton.Enabled := false;
  EditOriginSpeedButton.Enabled := false;
  DelTransSpeedButton.Enabled := false;
  EditTransSpeedButton.Enabled := false;
  PrevNextButtons;
end; // ResetForm

//////////////////////////////////////////////////////////////////////////////
// vyist formul
procedure TEditForm.ResetButtonClick(Sender: TObject);
begin
  ResetForm;
  Modified := true;
  FormModified := true;
end; // ResetButtonClick

//////////////////////////////////////////////////////////////////////////////
// posun na dal poloku seznamu
// pokud je na konci seznamu, piprav dal poloku k editaci
procedure TEditForm.NextButtonClick(Sender: TObject);
begin
  NextMove(ActualIndex + 1);
end; // NextButtonClick

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.LastButtonClick(Sender: TObject);
begin
  NextMove(List.Count);
end; // LastButtonClick


//////////////////////////////////////////////////////////////////////////////
// posune se na pedchoz poloku
// pokud je na zatku, mlo by bt toto tlatko zakzan
procedure TEditForm.PrevButtonClick(Sender: TObject);
begin
  PrevMove(ActualIndex - 1);  // posun o poloku zpt
end; // PrevButtonClick

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.FirstButtonClick(Sender: TObject);
begin
  PrevMove(0);                // posun na zatek
end; // FirstButtonClick

//////////////////////////////////////////////////////////////////////////////
// ukon aplikaci
procedure TEditForm.EndMClick(Sender: TObject);
begin
  Close;
end; // Konec1Click

//////////////////////////////////////////////////////////////////////////////
// vymae poloky z prvnho listboxu
procedure TEditForm.DelOriginSpeedButtonClick(Sender: TObject);
begin
  with OriginListBox do
  begin
    if ItemIndex = -1 then Exit;
    Items.Delete(ItemIndex);
  end;
  OriginSpeedButtons;
  Modified := true;
  FormModified := true;
end; // DelOriginSpeedButtonClick

//////////////////////////////////////////////////////////////////////////////
// vymae poloky z druhho listboxu
procedure TEditForm.DelTransSpeedButtonClick(Sender: TObject);
begin
  with TransListBox do
  begin
    if ItemIndex = -1 then Exit;
    Items.Delete(ItemIndex);
  end;
  TransSpeedButtons;
  Modified := true;
  FormModified := true;
end; // DelTransSpeedButtonClick

//////////////////////////////////////////////////////////////////////////////
// zjist monost editace poloek listboxu
procedure TEditForm.OriginListBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  OriginSpeedButtons;
end; // OriginListBoxMouseUp

//////////////////////////////////////////////////////////////////////////////
// zjist monost editace poloek listboxu
procedure TEditForm.OriginListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  OriginSpeedButtons;
end; // OriginListBoxKeyDown

//////////////////////////////////////////////////////////////////////////////
// zjist monost editace poloek listboxu
procedure TEditForm.TransListBoxMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TransSpeedButtons;
end; // TransListBoxMouseUp

//////////////////////////////////////////////////////////////////////////////
// zjist monost editace poloek listboxu
procedure TEditForm.TransListBoxKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  TransSpeedButtons;
end; // TransListBoxKeyDown

//////////////////////////////////////////////////////////////////////////////
// umon editaci vybran poloky listboxu
procedure TEditForm.EditOriginSpeedButtonClick(Sender: TObject);
begin
  with OriginListBox do
  begin
    if ItemIndex = -1 then Exit;
    OriginEdit.Text := Items[ItemIndex];
    Items.Delete(ItemIndex);
  end;
  OriginSpeedButtons;
  OriginEdit.SetFocus;
  Modified := true;
  FormModified := true;
end; // EditOriginSpeedButtonClick

//////////////////////////////////////////////////////////////////////////////
// umon editaci vybran poloky listboxu
procedure TEditForm.EditTransSpeedButtonClick(Sender: TObject);
begin
  with TransListBox do
  begin
    if ItemIndex = -1 then Exit;
    TransEdit.Text := Items[ItemIndex];
    Items.Delete(ItemIndex);
  end;
  TransSpeedButtons;
  TransEdit.SetFocus;
  Modified := true;
  FormModified := true;
end; // EditTransSpeedButtonClick

//////////////////////////////////////////////////////////////////////////////
// ulo seznam poloek do souboru
procedure TEditForm.SavAsMClick(Sender: TObject);
begin // UlozitjakoClick
  SaveDialog.FileName := FileName;
  if SaveDialog.Execute then
  begin
    if FileExists(SaveDialog.FileName) then
      if Application.MessageBox(PChar('Soubor '+SaveDialog.FileName+
         ' u existuje'+#13#10+'Pepsat jej?'), 'Uloit jako',
         MB_ICONWARNING + MB_YESNO + MB_DEFBUTTON1) = IDNO then Exit;
    List.SaveToFile(SaveDialog.FileName);
    FileName := ExtractFileName(SaveDialog.FileName);
    Modified := false;
    FormModified := false;
  end;
end; // UlozitjakoClick

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.OpenMClick(Sender: TObject);
begin
  if Modified then
    SaveMClick(Sender);
  if OpenDialog.Execute then
  begin
    FileName := OpenDialog.FileName;
    OpenFile;
    PrevNextButtons;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.NewMClick(Sender: TObject);
begin
  if Modified then SaveMClick(Sender);
  ResetForm;
  ListBox.Clear;
  OriginEdit.SetFocus;  // nastav zamen na prvn editovac box
  List.Free;
  List := TWordList.Create;  // vytvo seznam pro zznamy
  Modified := false;
  FormModified := false;
  FileName := NoName;
  FActualIndex := 2;
  FMaxIndex := 2;
  ActualIndex := 0;
  MaxIndex := 0;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.SaveMClick(Sender: TObject);
begin
  if FileName = NoName then
    begin
      SavAsMClick(Sender);
    end
  else
    begin
      List.SaveToFile(FileName);
      Modified := false;
      FormModified := false;
    end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  R : integer;
begin
  if Modified then
  begin
    R := Application.MessageBox('Seznam byl zmnn.'+#13#10+'Chcete jej uloit?',
      AppName, MB_YESNOCANCEL + MB_ICONQUESTION);
    if R = IDYES then
      SaveMClick(Sender)
    else if R = IDCANCEL then
      Action := caNone;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.OpMClick(Sender: TObject);
begin
  ShowAboutBox;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.ObsMClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
  Application.HelpCommand(HELP_QUIT, 0);
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.TransCommentEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Modified := true;
  FormModified := true;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TEditForm.OriginCommentEditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  Modified := true;
  FormModified := true;
end;

procedure TEditForm.ListBoxClick(Sender: TObject);
begin
  if ListBox.ItemIndex > MaxIndex then
    LastButtonClick(Sender)
  else
  begin
    if ActualIndex > ListBox.ItemIndex then
      NextMove(ListBox.ItemIndex)
    else if ActualIndex < ListBox.ItemIndex then
      PrevMove(ListBox.ItemIndex)
    else
      PrevNextButtons;  // pro jistotu
  end;
end;

end.

