/////////////////////////////////////////////////////////////////////////////
//  Projekt: STest - testovn slovek a tvorba test                     //
//  Verze: 2                                                               //
//  Autor: David Martinek                                                  //
//  Adresa: Majakovskho 2148/60, Karvin 7, 734 01                        //
//                                                                         //
//  Funkce modulu: Hlavn formul pro testovn                           //
//  Datum: 8.9.1999                                                       //
/////////////////////////////////////////////////////////////////////////////
unit MainFrm;
//{$DEFINE DEBUG}
interface

uses
  Windows, SysUtils, Forms, Dialogs, Menus, StdCtrls, Buttons, Controls,
  Classes, ExtCtrls,
  EditFrm, AboutFrm, WordList;

type
  TMainForm = class(TForm)
    Menu: TMainMenu;
    S1: TMenuItem;
    EditM: TMenuItem;
    EndM: TMenuItem;
    OpenM: TMenuItem;
    OpenDialog: TOpenDialog;
    HlpM: TMenuItem;
    ObsM: TMenuItem;
    N2: TMenuItem;
    OpM: TMenuItem;
    OptM: TMenuItem;
    N3: TMenuItem;
    OrigM: TMenuItem;
    TransM: TMenuItem;
    P1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    RemainLabel: TLabel;
    ProcessLabel: TLabel;
    ErrorsLabel: TLabel;
    SuccessLabel: TLabel;
    P2: TPanel;
    NewTestButton: TButton;
    P3: TPanel;
    OriginLabel: TLabel;
    Edit: TEdit;
    EnterSpeedButton: TSpeedButton;
    ModeLabel: TLabel;
    CommentLabel: TLabel;
    N4: TMenuItem;
    ZaznM: TMenuItem;
    AllM: TMenuItem;
    MLbl: TLabel;
    RepairButton: TButton;
    procedure EditMClick(Sender: TObject);
    procedure EndMClick(Sender: TObject);
    procedure OpenMClick(Sender: TObject);
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure EditChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure NewTestButtonClick(Sender: TObject);
    procedure EnterSpeedButtonClick(Sender: TObject);
    procedure OrigMClick(Sender: TObject);
    procedure TransMClick(Sender: TObject);
    procedure OpMClick(Sender: TObject);
    procedure ZaznMClick(Sender: TObject);
    procedure ObsMClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AllMClick(Sender: TObject);
    procedure RepairButtonClick(Sender: TObject);
  private
    { Private declarations }
    TempList : TWordList;  // test naten ze souboru
    TestList : TIndexList; // seznam index do seznamu TempList, tvo to test
    FProcess,
    FRemain,
    FErrors : integer;
    FSuccess : Single;
    FFileName,
    FMark : String;
    FNormalMode : TActualMode;  // smr zkouen

    ActualPair : TPair;
    APItem : TIndexItem;
    WordsInTest : integer;
    FTestMode : boolean;

    procedure NextPair;
    procedure CountSuccess;
    procedure LoadFile;

    procedure SetFileName(Value : String);
    procedure SetProcess(Value : integer);
    procedure SetRemain(Value : integer);
    procedure SetErrors(Value : integer);
    procedure SetSuccess(Value : Single);
    procedure SetNormalMode(Value : TActualMode);
    procedure SetTestMode(Value : Boolean);
  published
    { vlastnosti }
    // jmno aktuln otevenho souboru
    property FileName : string read FFileName write SetFileName;
    // zpracovno
    property Process : integer read FProcess write SetProcess;
    // zbv
    property Remain : integer read FRemain write SetRemain;
    // poet chyb
    property Errors : integer read FErrors write SetErrors;
    // spnost v procentech
    property Success : Single read FSuccess write SetSuccess;
    // uruje smr zkouen
    property NormalMode : TActualMode read FNormalMode write SetNormalMode;
    // uruje, jestli je prv uprosted testu
    property TestMode : Boolean read FTestMode write SetTestMode;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation
uses ErrFrm, ZaznFrm;

{$R *.DFM}

const
  VzdatQues = 'Opravdu to chcete vzdt?';

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.NextPair;
begin
  Edit.Text := '';
  if TestMode then
  begin
    // pete nhodn odkaz
    TestList.GetWord(APItem);
    ActualPair := TempList.Items[APItem.WIndex];
    NormalMode := APItem.Mode;

    OriginLabel.Caption := ActualPair.GetWord(APItem.Mode,APItem.Number);
    CommentLabel.Caption := ActualPair.GetComment(APItem.Mode);

    Edit.SetFocus;
  end
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.CountSuccess;
var
  TempProcess,
  TempErrors : Single;
begin
  if Errors = 0 then Success := 100
  else
  begin
    if Process = 0 then
    begin
      Success := 0;
      Exit;
    end;
    TempProcess := Process;
    TempErrors := Errors;
    Success := 100 - 100*TempErrors/TempProcess;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.SetFileName(Value : String);
begin
  if Value <> FFileName then
  begin
    FFileName := Value;
    Caption := AppName + ' - ' + ExtractFileName(Value);
    Application.Title := Caption;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.SetProcess(Value : integer);
begin
  FProcess := Value;
  ProcessLabel.Caption := IntToStr(Value);
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.SetRemain(Value : integer);
begin
  FRemain := Value;
  RemainLabel.Caption := IntToStr(Value);
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.SetErrors(Value : integer);
begin
  FErrors := Value;
  ErrorsLabel.Caption := IntToStr(Value);
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.SetSuccess(Value : Single);
var
  S : string[10];
begin
  FSuccess := Value;
  Str(Value:3:2, S);
  SuccessLabel.Caption := S + ' %';
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.SetNormalMode(Value : TActualMode);
begin
  FNormalMode := Value;
  case Value of
    amOrigin :
      begin
        OrigM.Checked := true;
        ModeLabel.Caption := 'Smr: Cizina --> etina';
        MLbl.Caption := 'esky:';
      end;
    amTrans :
      begin
        TransM.Checked := true;
        ModeLabel.Caption := 'Smr: etina --> Cizina';
        MLbl.Caption := 'Cize:';
      end;
    amMix :
      begin
        AllM.Checked := true;
        ModeLabel.Caption := '';
        MLbl.Caption := 'esky:';
      end;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.SetTestMode(Value : Boolean);
begin
  FTestMode := Value;
  if Value then
    NewTestButton.Caption := 'Vzdt'
  else
  begin
    NewTestButton.Caption := 'Nov test';
    OriginLabel.Caption := '';
    CommentLabel.Caption := '';
    Edit.Text := '';
  end;
  OptM.Enabled := not Value;
  OpenM.Enabled := not Value;
  EditM.Enabled := not Value;
  Edit.Enabled := Value;
  RepairButton.Enabled := Value;
  NewTestButton.Enabled := TempList <> nil;
end;

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.FormCreate(Sender: TObject);
var
  S : string;
begin
  Randomize;
  TestList := nil;
  TempList := nil;
  ActualPair := nil;
  FileName := NoName;
  NormalMode := LogOptions.NormalMode;
  APItem.WIndex := 0;
  if ParamCount > 0 then
  begin
    S := UpperCase(ExtractFileExt(ParamStr(1)));
    if (S <> '.TST') then
      Application.MessageBox(PChar('Soubor '+ParamStr(1)+#13#10+' nen platn testovac soubor.'),
        AppName, MB_OK + MB_ICONERROR)
    else
    begin
      FileName := ParamStr(1);
      LoadFile;
    end;
  end;
  TestMode := false;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.FormDestroy(Sender: TObject);
begin
  TestList.Free;
  TempList.Free;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.EndMClick(Sender: TObject);
begin
  Close;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.EditMClick(Sender: TObject);
begin
  if Edit.Enabled then
    NewTestButtonClick(Sender);
  TestList.Free; TestList := nil;
  TempList.Free; TempList := nil;
  Hide;   // hlavn formul se skryje
  ShowEditForm(FileName,APItem.WIndex);
  Show;   // hlavn formul se zase objev
  if FileName <> Noname then
  begin
    LoadFile;
  end;
  TestMode := false;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.LoadFile;
begin
  TempList.Free;
  TempList := TWordList.Create;
  TempList.LoadFromFile(FileName);
  if TempList.GetError > 0 then
    begin
      Application.MessageBox(PChar('Chyba pi natn souboru.'+#13#10+
        TempList.GetErrorText(TempList.GetError)), 'Chyba', mb_OK + mb_iconerror);
      TempList.Free;
      TempList := nil;
      FileName := NoName;
    end;
 end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.OpenMClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    FileName := OpenDialog.FileName;
    LoadFile;    // nate soubor do seznamu
    TestMode := false;
    RemainLabel.Caption := '';
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.EditKeyPress(Sender: TObject; var Key: Char);
begin
  if Edit.Text = '' then
  begin
    if Key = #32 then Key := #0;
  end
  else if Key = #13 then
  begin
    Key := #0;
    EnterSpeedButtonClick(Sender);
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.EditChange(Sender: TObject);
begin
  EnterSpeedButton.Enabled := (Edit.Text <> '') and (TestList <> nil);
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.NewTestButtonClick(Sender: TObject);
begin
  if TempList = nil then Exit;
  if TestMode then
  begin
    if Application.MessageBox(VzdatQues, AppName,
      MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON1) = IDNO then Exit;
    TestMode := false;
  end
  else
  begin
    if TestList <> nil then TestList.Free;
    TestList := TIndexList.Create(TempList, ActualMode, LogOptions.MaxLen);
    Errors := 0;
    Process := 0;

    Remain := TestList.Count;
    WordsInTest := TestList.Count;

    TestMode := Remain > 0;
    CountSuccess;
    NextPair;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.EnterSpeedButtonClick(Sender: TObject);
begin
  {$IFDEF DEBUG}
  if (Remain <> (TestList.Count + 1)) then
    Application.MessageBox('Bod 1, chybn kontroln souet!',AppName, MB_OK + MB_ICONERROR);
  {$ENDIF}

  Process := Process + 1;    // dal pokus

  // pokus se najt odpovdajc protjek
  if ActualPair.Find(OppositeMode(APItem.Mode),Trim(Edit.Text)) then // sprvn
  begin
    ActualPair := nil;
    TestList.ExtractActualWord;
    Remain := TestList.Count;

  {$IFDEF DEBUG}
  if (Remain <> (TestList.Count + 1)) then
    Application.MessageBox('Bod 2, chybn kontroln souet!',AppName, MB_OK + MB_ICONERROR);
  {$ENDIF}
    CountSuccess;
  end
  else  // patn
  begin
  {$IFDEF DEBUG}
  if (Remain <> (List.GetCount(ActualMode) + 1)) then
    Application.MessageBox('Bod 3, chybn kontroln souet!',AppName, MB_OK + MB_ICONERROR);
  {$ENDIF}

    Errors := Errors + 1;
    CountSuccess;
    ShowErrorForm(ActualPair.GetWordList(OppositeMode(APItem.Mode)));
  end;
  if TestList.Count <= 0 then
    TestMode := false;

  NextPair;

  if not TestMode then // test skonil, zobraz se vsledky
  begin
    TestList.Free;
    TestList := nil;
    if Success >= 85 then FMark := 'Vborn'
    else if Success >= 70 then FMark := 'Velmi dobe'
    else if Success >= 55 then FMark := 'Dobe'
    else FMark := 'Nedostaten';
    Application.MessageBox(Pchar(FMark), 'Vae znmka', MB_OK + MB_ICONINFORMATION);
    // zpis do log souboru
    WriteLogRecord(FileName, FMark, Success, Errors, WordsInTest);
  end;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.OrigMClick(Sender: TObject);
begin
  ActualMode := amOrigin;
  NormalMode := amOrigin;
  RemainLabel.Caption := '';
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.TransMClick(Sender: TObject);
begin
  ActualMode := amTrans;
  NormalMode := amTrans;
  RemainLabel.Caption := '';
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.AllMClick(Sender: TObject);
begin
  ActualMode := amMix;
  NormalMode := amMix;
  RemainLabel.Caption := '';
end;


//////////////////////////////////////////////////////////////////////////////
// zobraz dialog O programu
procedure TMainForm.OpMClick(Sender: TObject);
begin
  ShowAboutBox;
end;

//////////////////////////////////////////////////////////////////////////////
// zobraz dialog Zznam vsledk
procedure TMainForm.ZaznMClick(Sender: TObject);
begin
  ShowLogForm;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.ObsMClick(Sender: TObject);
begin
  Application.HelpCommand(HELP_FINDER, 0);
  Application.HelpCommand(HELP_QUIT, 0);
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if TestMode then
    if Application.MessageBox(VzdatQues, AppName,
      MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON1) = IDNO
    then
      Action := caNone
    else
      Action := caFree;
end;

//////////////////////////////////////////////////////////////////////////////
procedure TMainForm.RepairButtonClick(Sender: TObject);
begin
//  if TestMode then
    if Application.MessageBox('Opravdu peruit test a upravit jej?', AppName,
      MB_YESNO + MB_ICONQUESTION + MB_DEFBUTTON1) = IDNO
    then
      Exit;

  TestList.Free; TestList := nil;
  TempList.Free; TempList := nil;
  Hide;   // hlavn formul se skryje
  ShowEditForm(FileName,APItem.WIndex);
  Show;   // hlavn formul se zase objev
  if FileName <> Noname then
  begin
    LoadFile;
  end;
  TestMode := false;
  APItem.WIndex := 0;
end;

end.
